var app = angular.module('myApp', []);

// Definiujemy usługę gniazda jako wzorzec typu factory,
// aby została ustanowiona tylko raz, a tym samym działała jako singleton
// w zasięgu całej aplikacji.
app.factory('socket', function ($rootScope) {
  var socket = io.connect('http://localhost:8080');
  return {
    on: function (eventName, callback) {
      socket.on(eventName, function () {
        var args = arguments;
        $rootScope.$apply(function () {
          callback.apply(socket, args);
        });
      });
    },
    emit: function (eventName, data, callback) {
      socket.emit(eventName, data, function () {
        var args = arguments;
        $rootScope.$apply(function () {
          if (callback) {
            callback.apply(socket, args);
          }
        });
      })
    }
  };
});

function MainCtrl($scope, socket) {

  $scope.message = '';
  $scope.messages = [];

  // Otrzymujemy nowe zdarzenie msg z serwera.
  socket.on('new:msg', function (message) {
  $scope.messages.push(message);
});

// Poinformowanie serwera o nowej wiadomości.
$scope.broadcast = function() {
  socket.emit('broadcast:msg', {message: $scope.message});
  $scope.messages.push($scope.message);
  $scope.message = '';
};
}
